package com.cicdi.notify.template;

import com.cicdi.notify.NotifyType;

/**
 * 通知模板管理器，用于模板的转换
 *
 * @author xueye
 */
public interface TemplateManager {

    /**
     * @param type 模板类型
     * @param id   模板ID
     * @return 模板
     */
    Template getTemplate(NotifyType type, String id);

    /**
     * @param type       模板类型
     * @param properties 模板属性
     * @return 模板
     */
    Template createTemplate(NotifyType type, TemplateProperties properties);

    /**
     * 重新加载模板
     *
     * @param id 模板ID
     */
    void reload(String id);

    void register(TemplateProvider provider);
}
