package com.cicdi.notify.email;

import com.cicdi.notify.*;
import com.cicdi.notify.template.AbstractTemplateManager;
import com.cicdi.notify.template.Template;
import com.cicdi.notify.template.TemplateManager;
import com.cicdi.notify.template.TemplateProperties;
import com.simaek.notify.email.EmailProvider;
import com.simaek.notify.email.embedded.DefaultEmailNotifierProvider;
import org.junit.Test;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;

/**
 * @author xueye
 */
public class DefaultEmailTest {


    @Test
    public void testSend() {
        // 通知器配置管理器
        NotifyConfigManager notifyConfigManager = new NotifyConfigManager() {
            @Override
            public NotifierProperties getNotifyConfig(NotifyType notifyType, String configId) {
                NotifierProperties notifierProperties = new NotifierProperties();
                notifierProperties.setType(DefaultNotifyType.email.getId());
                notifierProperties.setProvider(EmailProvider.embedded.getId());
                notifierProperties.setId("12");

                Map<String, Object> config = new HashMap<>();

                config.put("host", "nas.xueye.io");
                config.put("port", 587);
                config.put("username", "xueye");
                config.put("password", "snow@PX1314");
                config.put("sender", "master@simaek.com");
                Map<String, Object> p1 = new HashMap<>();
                p1.put("name", "mail.smtp.starttls.enable");
                p1.put("value", "true");
                Map<String, Object> p2 = new HashMap<>();
                p2.put("name", "mail.smtp.auth");
                p2.put("value", "true");
                config.put("properties", Arrays.asList(p1, p2));
                notifierProperties.setConfiguration(config);
                return notifierProperties;
            }
        };

        // 模板管理器
        TemplateManager templateManager = new AbstractTemplateManager() {
            @Override
            protected TemplateProperties getProperties(NotifyType type, String id) {
                TemplateProperties templateProperties = new TemplateProperties();
                templateProperties.setType(DefaultNotifyType.email.getId());
                templateProperties.setProvider(EmailProvider.embedded.getId());
                templateProperties.setTemplate("{\"subject\":\"Hello\",\"sendTo\":[\"xueye404@qq.com\"],\"text\":\"<p>This is a test</p>\",\"attachments\":[]}");
                return templateProperties;
            }
        };

        NotifierManager notifierManager = new DefaultNotifierManager(notifyConfigManager);
        DefaultEmailNotifierProvider defaultEmailNotifierProvider = new DefaultEmailNotifierProvider(templateManager);
        // register
        notifierManager.registerProvider(defaultEmailNotifierProvider);
        templateManager.register(defaultEmailNotifierProvider);

        Notifier<Template> notifier = notifierManager.getNotifier(DefaultNotifyType.email, "123");
        notifier.send(templateManager.getTemplate(DefaultNotifyType.email, "124"), new HashMap<>());
    }
}
